public class List02{
   static int thread_num =5;

   public static void main(String[] args){
      List02Data data = new List02Data();
      for (int id=0;id<thread_num;id++){
         new List02Worker(id,data).start();
      }
   }
}

class List02Data{
   private int para_1;
   private int para_2;
   
   public synchronized void setData(int id){
      System.out.println("set:"+id);
      this.para_1 = id;
      try{
         //ő0.5b̑҂
         Thread.sleep((long)(Math.random()*500));
      }catch(InterruptedException e){}
      this.para_2 = id;
      checkData(id);
   }
   
   private void checkData(int id){
      System.out.println("check:"+id);
      if(para_1==para_2){
         System.out.println("-------ok");
      }else{
         System.out.println("-------failure");
      }
   }
}

class List02Worker extends Thread{
   private int id;
   private List02Data data;
   
   public List02Worker(int id,List02Data data){
      this.id = id;
      this.data = data;
   }

   public void run(){
      for(int i=0;i<10;i++){
         data.setData(id);
      }
   }
}
