public class List03{
   static int thread_num =5;

   public static void main(String[] args){
      for (int id=0;id<thread_num;id++){
         new List03Worker(id).start();
      }
   }
}

class List03Data{
   private int para_1;
   private int para_2;
   
   public synchronized void setData(int id){
      System.out.println("set:"+id);
      para_1 = id;
      try{
         //ő0.5b̑҂
         Thread.sleep((long)(Math.random()*500));
      }catch(InterruptedException e){}
      para_2 = id;
      checkData(id);
   }
   
   private void checkData(int id){
      System.out.println("check:"+id);
      if(para_1==para_2){
         System.out.println("-------ok");
      }else{
         System.out.println("-------failure");
      }
   }
}

class List03Worker extends Thread{
   private int id;
   private List03Data data = new List03Data();
   
   public List03Worker(int id){
      this.id = id;
   }

   public void run(){
      for(int i=0;i<10;i++){
         data.setData(id);
      }
   }
}
