import java.util.*;

/*CEXbh*/
public class List11{

   public static void main(String[] args){
      List11Data data = new List11Data();
      int thread_num = 5;   //׃Xbh
      
      //Ԍv̊Jn
      long start =(new Date()).getTime();

      //Xbh𐶐
      Thread worker[] = new Thread[thread_num];;
      for (int id=0;id<thread_num;id++){
         worker[id] = new List11Worker(data);
         worker[id].start();
      }

      //XbhȊ҂킹
      try{
         for(int id=0;id<thread_num;id++){
            worker[id].join();
         }
      }catch(InterruptedException e){}
   
      //Ԃ̌vZ(unit:ms)
      long end =(new Date()).getTime();
      System.out.println("Xbh̕Ϗx(ms): "+(end-start)/thread_num);

   }
}

/*׃eX^[*/
class List11Worker extends Thread{
   private List11Data data = new List11Data();

   public List11Worker(List11Data data){
      this.data = data;
   }
   
   public void run(){
      //ЂƂ̃Xbh5ÂǏs
      for(int i=0;i<5;i++){
         try{
            data.readDataRequest();
            data.writeDataRequest();
         }catch(InterruptedException e){}
      }
   }
}

/*f[^\[X*/
class List11Data{
   private final List11Lock lock = new List11Lock();
   
   public void readDataRequest() throws InterruptedException{
      lock.readLock();
      readData();
      lock.done();
   }
   
   public void writeDataRequest() throws InterruptedException{
      lock.writeLock();
      writeData();
      lock.done();
   }
   
   private void readData(){
      System.out.println("------readData");
      //f[^ǍށBTvł̓_~[ׂ`
      try{
            //ő5b̑҂
         Thread.sleep((long)(Math.random()*5000));
      }catch(InterruptedException e){}
   }
   
   private void writeData(){
      System.out.println("++++++writeData");
      //f[^ށBTvł͉Ȃ
   }
}

/*bN*/
class List11Lock{
   private int activeReaders = 0;
   private int activeWriters = 0;
   private int pendingWriters = 0;
   
   /*Ǎ݃bN̎擾*/
   protected synchronized void readLock() throws InterruptedException{
      while(pendingWriters + activeWriters > 0){
         wait();
      }
      activeReaders++;   //Ǎ݃Xbh
   }

   /*݃bN̎擾*/
   protected synchronized void writeLock() throws InterruptedException{
      pendingWriters++;   //Ǎ݃ubN
      while(activeReaders + activeWriters > 0){
         wait();
      }
      pendingWriters--;
      activeWriters++;   //݃Xbh
   }

   /*bN̉*/
   protected synchronized void done(){
      if(activeWriters > 0){
         activeWriters--;
      }else if(activeReaders > 0){
         activeReaders--;
      }else{
         System.out.println("Lock Error!");
      }
      notifyAll();
   }
}